/* $Id: pop.h,v 1.27 2003/10/04 07:24:52 chrisf Exp $ */

/*
GNU Got Mail - An SMTP/POP3 client for the PalmPilot
Copyright (C) 1999 Chris Faherty

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#ifndef __POP_H__
#define __POP_H__

#define HDRFIELDS 10

enum Actions {
    actMATCH,
	actISWHITE,
    actWAITFOR,
	actGETNUM,
	actGETHEADER,
	actGETBODY
};

enum States {
    stOPEN, stOPEN2,
    stUSER, stUSER2,
    stPASS, stPASS2,
    stAPOP,
    stSTAT, stSTAT2, stSTAT3,
    stUIDL, stUIDL1, stUIDL2, stUIDL3, stUIDL4, stUIDL5,
	stLIST, stLIST1, stLIST2, stLIST3, stLIST4, stLIST5, stLIST6,
    stHTTPSTART, stHTTPSTART2, stHTTPSTART21, stHTTPSTART3, stHTTPSTART4,
	stRETR, stRETR2, stRETR3, stRETR4, stRETR5,
	stHEAD, stHEAD2, stHEAD3,
	stBODY,
    stDELE, stDELE2,
	stQUIT, stQUIT2,
    stERROR, stERROR2,
	stALLDONE
};

struct spopdata {
    Int16 error;
	Int32 msgnum;
    Int32 msgstotal;
    Int32 startmsg;
    Int32 maxlines;
	char *msgrec;
	Int32 msgreccnt;
	Int32 msgrecsize;
	Int32 msgrectotalcnt;
	Int32 msgrectotalsize;
	MemHandle msgrechandle;
	UInt16 msgrecindex;
	char *patt, *pattb;
	char numbuf[11];
	Int16 numbufcnt, hdrfield;
	Int32 HDRoff[HDRFIELDS], HDRlen[HDRFIELDS];
	Int16 parseAction, parseState, keepdata, skipdata;
    struct ssq sq;
    Int16 isdotfound;
    Int16 charsinline;
    Int16 softret;
    Int16 inquote;
    Boolean justhighmsg;
    Boolean onlylogin;
    Boolean wasreset;
    Boolean usehttp;
    Boolean isgzip;
};

Int32 poptick(struct spopdata *pd, const char *new, Int16 count, int clsock);
Boolean writeheaders(void);
Boolean addtorecord(char *str, Int16 len);
Boolean beginnewrecord(void);
void endnewrecord(void);
void removenewrecord(void);

#endif
