/* $Id: common.h,v 1.18 2003/10/04 07:24:52 chrisf Exp $ */

/*
GNU Got Mail - An SMTP/POP3 client for the PalmPilot
Copyright (C) 1999 Chris Faherty

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#ifndef __COMMONX_H__
#define __COMMONX_H__

#ifndef UCASE
#define UCASE(_a) ((_a)>='a' && (_a)<='z' ? (_a)-32:(_a))
#endif
#ifndef WSPACE
#define WSPACE(_a) ((_a)=='\t' ? ' ':(_a))
#endif
#ifndef	MAX
#define	MAX(_a,_b) ((_a)<(_b)?(_b):(_a))
#endif
#ifndef	MIN
#define	MIN(_a,_b) ((_a)<(_b)?(_a):(_b))
#endif
#ifndef	ABS
#define	ABS(_a) ((_a)>=0?(_a):-(_a))
#endif
#ifndef offsetof
#define offsetof(s,m) ((UInt16)&(((s *)0)->m))
#endif

struct ssq {
    char *sendq;
    Int16 sendqin, sendqout;
};

/* function prototypes */

Int16 numtotxt(Int32 num, char *txt, Boolean leadingzeroes);
void ShowStatusLine(Boolean force);
Int16 DrawChars(char *str, UInt16 len, Int16 x, Int16 y);
void DrawMsg(RectangleType r, char *str);
void ShowInfoMsg(char *str);
void SetErrorMsg(char *str);
void ShowErrorMsg(char *str);
void ShowHeader(char *from, char *subject);
void ShowFileInfo(Int16 title, char *name);
Boolean DrawWrapped(RectangleType *r, char *str);
void ShowProgress(Boolean force, char *str, Int32 num, Int32 den, Int32 num2,
    Int32 den2);
void ShowProgressBar(Int32 num, Int32 den);
void ShowButtons(Int16 which);
void HideIcons(void);
void ShowIcons(void);
Boolean BuildIcons(void);
DmOpenRef OpenIconDatabase(UInt32 creator, UInt32 resType, Int16 typeIndex,
    Int16 *i);
UInt32 GetOSFreeMem(UInt32 *totalMemoryP, UInt32 *dynamicMemoryP);

#endif
